<template>
  <ValidationObserver v-slot="{ handleSubmit }">
    <CForm
      v-loading="loading"
      class="user-form"
      @submit.prevent="handleSubmit(onSubmit)"
    >
      <CCard>
        <CCardBody>
          <div class="box-inner-form">
            <div class="row">
              <div class="col-12 col-lg-6">
                <ValidationProvider v-slot="{ errors }" rules="required|email">
                  <CInput
                    v-model="model.email"
                    type="text"
                    label="メールアドレス"
                    placeholder="メールアドレス"
                    horizontal
                  >
                    <template #prepend-content>
                      <font-awesome-icon :icon="['fas', 'envelope']" class="width-1x" />
                    </template>
                    <template #invalid-feedback>
                      <div class="d-block invalid-feedback">
                        {{ errors[0] }}
                      </div>
                    </template>
                  </CInput>
                </ValidationProvider>
              </div>

              <div class="col-12 col-lg-6">
                <ValidationProvider v-slot="{ errors }" rules="required">
                  <CInput
                    v-model="model.name"
                    type="text"
                    label="お名前"
                    placeholder="お名前"
                    horizontal
                  >
                    <template #prepend-content>
                      <font-awesome-icon :icon="['fas', 'user-tie']" class="width-1x" />
                    </template>
                    <template #invalid-feedback>
                      <div class="d-block invalid-feedback">
                        {{ errors[0] }}
                      </div>
                    </template>
                  </CInput>
                </ValidationProvider>
              </div>
            </div>

            <div class="row">
              <div class="col-12 col-lg-6">
                <ValidationProvider v-slot="{ errors }" :rules="id ? 'confirmed:rePassword' : 'required|confirmed:rePassword'">
                  <CInput
                    v-model="model.password"
                    type="password"
                    label="パスワード"
                    placeholder="パスワード"
                    horizontal
                  >
                    <template #prepend-content>
                      <font-awesome-icon :icon="['fas', 'lock']" class="width-1x" />
                    </template>
                    <template #invalid-feedback>
                      <div class="d-block invalid-feedback">
                        {{ errors[0] }}
                      </div>
                    </template>
                  </CInput>
                </ValidationProvider>
              </div>

              <div class="col-12 col-lg-6">
                <ValidationProvider v-slot="{ errors }" :rules="id ? '' : 'required'" vid="rePassword">
                  <CInput
                    v-model="rePassword"
                    type="password"
                    label="パスワード（確認）"
                    placeholder="パスワード（確認"
                    horizontal
                  >
                    <template #prepend-content>
                      <font-awesome-icon :icon="['fas', 'lock']" class="width-1x" />
                    </template>
                    <template #invalid-feedback>
                      <div class="d-block invalid-feedback">
                        {{ errors[0] }}
                      </div>
                    </template>
                  </CInput>
                </ValidationProvider>
              </div>
            </div>

            <div class="row">
              <div class="col-12 col-lg-6">
                <CInput
                  v-model="model.phone"
                  type="text"
                  label="電話番号"
                  placeholder="電話番号"
                  horizontal
                >
                  <template #prepend-content>
                    <font-awesome-icon :icon="['fas', 'phone']" class="width-1x" />
                  </template>
                </CInput>
              </div>

              <div class="col-12 col-lg-6">
                <ValidationProvider v-slot="{ errors }" rules="required">
                  <div role="group" class="form-group form-row">
                    <CCol tag="label" sm="3" class="col-form-label">
                      ご参加
                    </CCol>
                    <CCol sm="9" class="form-inline">
                      <app-radio-group
                        v-model="model.participation"
                        :list="PARTICIPATION_LIST"
                        :name="'participation'"
                      />
                      <template #invalid-feedback>
                        <div class="d-block invalid-feedback">
                          {{ errors[0] }}
                        </div>
                      </template>
                    </CCol>
                  </div>
                </ValidationProvider>
              </div>
            </div>

            <div class="row">
              <div class="col-12 col-lg-6">
                <CInput
                  v-model="model.furigana"
                  type="text"
                  label="フリガナ"
                  placeholder="フリガナ"
                  horizontal
                >
                  <template #prepend-content>
                    <font-awesome-icon :icon="['fas', 'band-aid']" class="width-1x" />
                  </template>
                </CInput>
              </div>

              <div class="col-12 col-lg-6">
                <CInput
                  v-model="model.corporate_name"
                  type="text"
                  label="法人名"
                  placeholder="Enter 法人名"
                  horizontal
                >
                  <template #prepend-content>
                    <font-awesome-icon :icon="['fas', 'user-tie']" class="width-1x" />
                  </template>
                </CInput>
              </div>
            </div>

            <div class="row">
              <div class="col-12 col-lg-6">
                <CInput
                  v-model="model.department_name"
                  type="text"
                  label="部署名"
                  placeholder="部署名"
                  horizontal
                >
                  <template #prepend-content>
                    <font-awesome-icon :icon="['fas', 'suitcase']" class="width-1x" />
                  </template>
                </CInput>
              </div>

              <div class="col-12 col-lg-6">
                <CInput
                  v-model="model.position_name"
                  type="text"
                  label="役職名"
                  placeholder="役職名"
                  horizontal
                >
                  <template #prepend-content>
                    <font-awesome-icon :icon="['fas', 'ambulance']" class="width-1x" />
                  </template>
                </CInput>
              </div>
            </div>

            <div class="row">
              <div class="col-12 col-lg-6">
                <CInput
                  v-model="model.participant_number"
                  type="text"
                  label="参加人数"
                  placeholder="参加人数"
                  horizontal
                >
                  <template #prepend-content>
                    <font-awesome-icon :icon="['fas', 'question-circle']" class="width-1x" />
                  </template>
                </CInput>
              </div>

              <div class="col-12 col-lg-6">
                <ValidationProvider v-slot="{ errors }" rules="required">
                  <CInput
                    v-model="model.postal_code"
                    type="text"
                    label="郵便番号"
                    placeholder="郵便番号"
                    horizontal
                  >
                    <template #prepend-content>
                      <font-awesome-icon :icon="['fas', 'envelope']" class="width-1x" />
                    </template>
                    <template #invalid-feedback>
                      <div class="d-block invalid-feedback">
                        {{ errors[0] }}
                      </div>
                    </template>
                  </CInput>
                </ValidationProvider>
              </div>
            </div>

            <div class="row">
              <div class="col-12 col-lg-6">
                <CInput
                  v-model="model.address"
                  type="text"
                  label="ご住所"
                  placeholder="ご住所"
                  horizontal
                >
                  <template #prepend-content>
                    <font-awesome-icon :icon="['fas', 'ethernet']" class="width-1x" />
                  </template>
                </CInput>
              </div>

              <div class="col-12 col-lg-6">
                <CInput
                  v-model="model.phone"
                  type="text"
                  label="電話番号"
                  placeholder="電話番号"
                  horizontal
                >
                  <template #prepend-content>
                    <font-awesome-icon :icon="['fas', 'phone']" class="width-1x" />
                  </template>
                </CInput>
              </div>
            </div>

            <div class="row">
              <div class="col-12 col-lg-6">
                <CInput
                  v-model="model.fax"
                  type="text"
                  label="FAX番号"
                  placeholder="FAX番号"
                  horizontal
                >
                  <template #prepend-content>
                    <font-awesome-icon :icon="['fas', 'phone']" class="width-1x" />
                  </template>
                </CInput>
              </div>

              <div class="col-12 col-lg-6">
                <CInput
                  v-model="model.note"
                  type="text"
                  label="備考"
                  placeholder="備考"
                  horizontal
                >
                  <template #prepend-content>
                    <font-awesome-icon :icon="['fas', 'info-circle']" class="width-1x" />
                  </template>
                </CInput>
              </div>
            </div>

            <div class="row">
              <CCol tag="label" sm="3" class="col-form-label">
                本人確認書類（個人）
              </CCol>
            </div>
            <div class="row">
              <div class="col-12 col-lg-6">
                <CInputFile
                  label="表面"
                  horizontal
                  custom
                  class="form-group"
                />

                <div role="group" class="form-group form-row">
                  <CCol tag="label" sm="3" class="col-form-label" />
                  <CCol sm="9">
                    <img src="https://placeimg.com/700/300/any" alt="demo">
                  </CCol>
                </div>
              </div>

              <div class="col-12 col-lg-6">
                <CInputFile
                  label="裏面"
                  horizontal
                  custom
                  class="form-group"
                />

                <div role="group" class="form-group form-row">
                  <CCol tag="label" sm="3" class="col-form-label" />
                  <CCol sm="9">
                    <img src="https://placeimg.com/700/300/any" alt="demo">
                  </CCol>
                </div>
              </div>
            </div>

            <div class="row">
              <CCol tag="label" sm="3" class="col-form-label">
                古物許可証（ファイル）
              </CCol>
            </div>
            <div class="row">
              <div class="col-12 col-lg-6">
                <CInputFile
                  label="法人"
                  horizontal
                  custom
                  class="form-group"
                />

                <div role="group" class="form-group form-row">
                  <CCol tag="label" sm="3" class="col-form-label" />
                  <CCol sm="9">
                    <img src="https://placeimg.com/700/300/any" alt="demo">
                  </CCol>
                </div>
              </div>
            </div>
          </div>
        </CCardBody>

        <CCardFooter>
          <CButton
            type="submit"
            color="primary"
          >
            <font-awesome-icon :icon="['fas', 'save']" class="width-1x" />
            会員登録する
          </CButton>

          <CButton
            color="secondary"
            @click="$emit('close')"
          >
            <font-awesome-icon :icon="['fas', 'times-circle']" class="width-1x" />
            いいえ
          </CButton>
        </CCardFooter>
      </CCard>
    </CForm>
  </ValidationObserver>
</template>

<style lang="scss" scoped>
  .user-form {
    .card {
      border-top: 0;
      margin-bottom: 0;
    }
  }
</style>

<script>
import {
  PARTICIPATION_LIST
} from '~/constants'

import AppRadioGroup from '~/components/atoms/AppRadioGroup'
import User from '~/models/User'
import createEditForm from '~/mixins/create-edit-form'

export default {
  components: {
    AppRadioGroup
  },

  mixins: [
    createEditForm
  ],

  data () {
    return {
      rePassword: '',
      model: new User(),
      modelType: 'user'
    }
  },

  computed: {
    /**
     * Get PARTICIPATION_LIST
     *
     * @return {Array} PARTICIPATION_LIST
     */
    PARTICIPATION_LIST () {
      return PARTICIPATION_LIST
    }
  },

  methods: {
    /**
     * set user status
     * @param {Boolean} val
     * @param {Object} event
     */
    setStatus (val, event) {
      this.model.status = parseInt(event.target.value)
    },

    /**
     * Dynamic set model
     * @param {Object} data
     */
    setModel (data) {
      this.model = new User(data)
    },

    /**
     * prepareData
     */
    prepareData () {
    }
  }
}
</script>
